package multiplerowscellstableselection;

/**
 * use a left mouse double click at the column header boundary
 * to set column size with the WidthAdjuster
 * Class WidthAdjuster @author unknown, code found at:
 * https://community.oracle.com/thread/1478426
 * 
 * Class MultipleSelectionRenderer based on Class ColoredTableRenderer,
 * @author unknown, code found at:
 * http://www.java2s.com/Code/Java/Swing-JFC/ColoredTableCellRenderer.htm
 * 
 * 
 * Class RegexMatches @author unknown, code found at:
 * http://www.tutorialspoint.com/java/java_regular_expressions.htm
 * 
 * 
 * Class MultiSelectionTableDemo @author walter hipp
 */

public class MultiSelectionTableDemo extends javax.swing.JPanel
{
    private javax.swing.JTable      table;
    private static javax.swing.JTextArea output = new javax.swing.JTextArea(1, 10);
    static int selectionOffset   = 0;
    private int                    whatTable;
    private String[] columnNames = null;
    private String[][] tableData = null;
    
    
    public MultiSelectionTableDemo(int tblToCreate)
    {
        super(new java.awt.BorderLayout());
        whatTable = tblToCreate;
        buildTable(whatTable);

        // Build output area.
        //output = new javax.swing.JTextArea(1, 10);
        output.setEditable(false);
        
        table = new javax.swing.JTable(tableData, columnNames);
        if (whatTable > 1)
        {
            new WidthAdjuster(table); // used with calendar table
            setTableColumSizes(table); // used with calendar table
            setEmtyTable(table, 2015); // used with calendar table
        } 
        table.setColumnSelectionAllowed(false);
        table.setRowSelectionAllowed(false);
        table.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        MultipleRowsCellsTableSelection mrc = 
                new MultipleRowsCellsTableSelection(output);
        mrc.setTblListeners(table);
        table.setDefaultRenderer(Object.class,
                    new MultipleSelectionRenderer());
        
        
        javax.swing.JScrollPane tablePane = new javax.swing.JScrollPane(table);
        javax.swing.JScrollPane outputPane = new javax.swing.JScrollPane(output,
            javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
            javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        
        // Do the layout.
        javax.swing.JSplitPane splitPane = 
              new javax.swing.JSplitPane(javax.swing.JSplitPane.VERTICAL_SPLIT);
        splitPane.setDividerLocation(280);
        add(splitPane, java.awt.BorderLayout.CENTER);

        javax.swing.JPanel topHalf = new javax.swing.JPanel();
        topHalf.setLayout(new java.awt.BorderLayout());
        
        tablePane.setBorder(javax.swing.BorderFactory.createTitledBorder("Table"));
        tablePane.setPreferredSize(new java.awt.Dimension(420, 380));
        topHalf.setBorder(javax.swing.BorderFactory.createEmptyBorder(5, 5, 0, 5));
        topHalf.add(tablePane, java.awt.BorderLayout.NORTH);
        
        topHalf.setMinimumSize(new java.awt.Dimension(250, 200));
        topHalf.setPreferredSize(new java.awt.Dimension(250, 380));
        splitPane.add(topHalf);

        javax.swing.JPanel bottomHalf = new javax.swing.JPanel(new java.awt.BorderLayout());
        bottomHalf.add(outputPane, java.awt.BorderLayout.CENTER);
        // XXX: next line needed if bottomHalf is a scroll pane:
        // bottomHalf.setMinimumSize(new Dimension(400, 50));
        bottomHalf.setPreferredSize(new java.awt.Dimension(420, 110));
        splitPane.add(bottomHalf);
    }
    
    private void buildTable(int tblToCreate)
    {
        if (tblToCreate == 1)
        {
             columnNames = new String[] { "French", "Spanish", "Italian", "  German" };
             tableData = new String[][]{ { "un", "uno", "uno", "eins" }, { "deux", "dos", "due", "zwei" },
                { "trois", "tres", "tre", "drei" }, { "quatre", "cuatro", "quattro", "vier" },
                { "cinq", "cinco", "cinque", "fünf" }, { "six", "seis", "sei", "sechs" },
                { "sept", "siete", "sette", "sieben" } }; // Simple Table use it instead of calendar table
        }
        else
        {
            tableData = new String[][]{
                {"December", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"January", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"February", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"March", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"April", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"May", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"June", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"July", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"August", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"September", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"October", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"November", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"December", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {"January", null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null}
            };
            columnNames = new String[] {
                "", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31"
                };
            selectionOffset = 1;
        }
    }
    
    private void setTableColumSizes(javax.swing.JTable table) // used with calendar table
    {
      javax.swing.table.TableColumn column = null;
      for (int i = 0; i < table.getColumnCount(); i++)
      {
        column = table.getColumnModel().getColumn(i);
        switch (i)
        {
          case 0:  column.setPreferredWidth(80);
                   break;
          default: column.setPreferredWidth(25);
                   break;
        }
      }
    }
    
    public void setEmtyTable(javax.swing.JTable tbl, int j) // used with calendar table
    {
        String y[] = null;
        int startDay = WeekDay.dayOfWeek(1, 12, j-1);
        int endDay = multiplerowscellstableselection.wappcalendar.HandleCalendar.getMonthMaxDay(12, j-1);
        for (int xx = 1; xx <= endDay; xx++)
        {
                tbl.setValueAt(WeekDay.weekDay[startDay++] + " ", 0, xx);
                if (startDay > 6) startDay = 0;
        }
        //multiplerowscellstableselection.wappcalendar.Feiertage.storeBeweglicheFeiertage(j-1);
        y = tbl.getValueAt(0, 0).toString().split(" ");
        tbl.setValueAt(y[0] + " " + (j-1), 0, 0);
        for (int x = 1; x <= 12; x++)
        {
            y = tbl.getValueAt(x, 0).toString().split(" ");
            tbl.setValueAt(y[0] + " " + j, x, 0);
            startDay = WeekDay.dayOfWeek(1, x, j);
            endDay = multiplerowscellstableselection.wappcalendar.HandleCalendar.getMonthMaxDay(x, j);
            for (int xx = 1; xx <= endDay; xx++)
            {
                tbl.setValueAt(WeekDay.weekDay[startDay++] + " ", x, xx);
                if (startDay > 6) startDay = 0;
            }
        }
        startDay = WeekDay.dayOfWeek(1, 1, j+1);
        endDay = multiplerowscellstableselection.wappcalendar.HandleCalendar.getMonthMaxDay(1, j+1);
        //newabwhproject.wappcalendar.Feiertage.storeBeweglicheFeiertage(j+1);
        for (int xx = 1; xx <= endDay; xx++)
        {
                tbl.setValueAt(WeekDay.weekDay[startDay++] + " ", 13, xx);
                if (startDay > 6) startDay = 0;
        }
        y = tbl.getValueAt(1, 0).toString().split(" ");
        tbl.setValueAt(y[0] + " " + (j+1), 13, 0);
    }
    
    /**
    * Create the GUI and show it. For thread safety, this method should be
    * invoked from the event-dispatching thread.
    */
    private static void createAndShowGUI()
    {
        // Create and set up the window.
        javax.swing.JFrame frame = new javax.swing.JFrame("TableSelectionDemo");
        frame.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        javax.swing.JCheckBox checkbox = new javax.swing.JCheckBox("Use different selection colors.");
        Object[] possibleValues = new Object[2];
        possibleValues[0] = "Simple Table";
        possibleValues[1] = "Calendar Table";
        String msg = "2 tables are available";
        Object[] msgContent = {msg, checkbox}; 
                
        Object selectedValue = 
                        javax.swing.JOptionPane.showInputDialog(frame, //null,
                            msgContent, "please choose a table",
                            javax.swing.JOptionPane.INFORMATION_MESSAGE, null, possibleValues, possibleValues[0]);
        if (selectedValue != null)
        {
            int sel = 2;
            if (selectedValue.equals("Simple Table"))
                    sel = 1;
            output.append("Your selection: " + selectedValue + 
                    System.getProperty("line.separator"));
            if (checkbox.isSelected())
                MultipleSelectionRenderer.coloredTest = true;
            // Create and set up the content pane.
            MultiSelectionTableDemo demo = new MultiSelectionTableDemo(sel);
            demo.setOpaque(true);
            frame.setContentPane(demo);

            // Display the window.
            frame.setPreferredSize(new java.awt.Dimension(1100, 500));
            frame.pack();
            frame.setVisible(true);
        }
        else System.exit(0);
       
    }

     public static void main(String[] args)
    {
        // Schedule a job for the event-dispatching thread:
        // creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable()
        {
            public void run()
            {
                createAndShowGUI();
            }
        });
    }
}
